Bug 1013095 - Review Request: cube - CUBE Uniform Behavioral Encoding generic presentation component
Review Request: cube - CUBE Uniform Behavioral Encoding generic presentation ...
Status: CLOSED NEXTRELEASE
Product: Fedora
Classification: Fedora
Component: Package Review (Show other bugs)
rawhide
All Linux
medium Severity medium
: ---
: ---
Assigned To: Mukundan Ragavan
Fedora Extras Quality Assurance
:
Depends On:
Blocks: 1013836
  Show dependency treegraph
 
Reported: 2013-09-27 16:21 EDT by Orion Poplawski
Modified: 2014-03-27 19:15 EDT (History)
2 users (show)

See Also:
Fixed In Version:
Doc Type: Bug Fix
Doc Text:
Story Points: ---
Clone Of:
Environment:
Last Closed: 2014-03-27 19:15:18 EDT
Type: Bug
Regression: ---
Mount Type: ---
Documentation: ---
CRM:
Verified Versions:
Category: ---
oVirt Team: ---
RHEL 7.3 requirements from Atomic Host:
Cloudforms Team: ---
nonamedotc: fedora‑review+
limburgher: fedora‑cvs+


Attachments (Terms of Use)

  None (edit)
Description Orion Poplawski 2013-09-27 16:21:06 EDT
Spec URL: http://www.cora.nwra.com/~orion/fedora/cube.spec
SRPM URL: http://www.cora.nwra.com/~orion/fedora/cube-4.2-1.fc19.src.rpm
Description: 
CUBE (CUBE Uniform Behavioral Encoding) is a generic presentation component
suitable for displaying a wide variety of performance metrics for parallel
programs including MPI and OpenMP applications. CUBE allows interactive
exploration of a multidimensional performance space in a scalable fashion.
Scalability is achieved in two ways: hierarchical decomposition of individual
dimensions and aggregation across different dimensions. All performance
metrics are uniformly accommodated in the same display and thus provide the
ability to easily compare the effects of different kinds of performance
behavior.
Comment 1 Orion Poplawski 2013-10-02 18:01:06 EDT
* Wed Oct 2 2013 Orion Poplawski <orion@cora.nwra.com> - 4.2-2
- Use patch to fix up various libdir paths
- Modify configure to remove rpath

http://www.cora.nwra.com/~orion/fedora/cube.spec
http://www.cora.nwra.com/~orion/fedora/cube-4.2-2.fc19.src.rpm
Comment 2 Orion Poplawski 2013-11-08 12:11:31 EST
* Fri Nov 8 2013 Orion Poplawski <orion@cora.nwra.com> - 4.2-3
- Fix 32bit build

Spec URL: http://www.cora.nwra.com/~orion/fedora/cube.spec
SRPM URL: http://www.cora.nwra.com/~orion/fedora/cube-4.2-3.fc19.src.rpm
Comment 3 Orion Poplawski 2014-02-26 14:01:41 EST
Spec URL: http://www.cora.nwra.com/~orion/fedora/cube.spec
SRPM URL: http://www.cora.nwra.com/~orion/fedora/cube-4.2.1-1.fc20.src.rpm

* Wed Feb 26 2014 Orion Poplawski <orion@cora.nwra.com> - 4.2.1-1
- Update to 4.2.1
Comment 4 Orion Poplawski 2014-02-28 12:57:33 EST
Spec URL: http://www.cora.nwra.com/~orion/fedora/cube.spec
SRPM URL: http://www.cora.nwra.com/~orion/fedora/cube-4.2.1-2.fc20.src.rpm

* Fri Feb 28 2014 Orion Poplawski <orion@cora.nwra.com> - 4.2.1-2
- Add %%check
Comment 5 Mukundan Ragavan 2014-02-28 13:00:24 EST
I will take this.
Comment 6 Mukundan Ragavan 2014-03-02 00:00:53 EST
There are some issues with the package. Please see the detailed review below. If I can clarify any points, please let me know.


Package Review
==============

Legend:
[x] = Pass, [!] = Fail, [-] = Not applicable, [?] = Not evaluated
[ ] = Manual review needed


Issues:
=======
- Packages have proper BuildRequires/Requires on jpackage-utils

---> BuildRequires and cube-java has Requires: jpackage-utils - looks fine. Does cube also require this? Requires does not show that below.

- gtk-update-icon-cache is invoked in %postun and %posttrans if package
  contains icons.
  Note: icons in cube
  See: http://fedoraproject.org/wiki/Packaging:ScriptletSnippets#Icon_Cache
- Javadocs are placed in %{_javadocdir}/%{name} (no -%{version} symlink)
  Note: No javadoc subpackage present
  See: https://fedoraproject.org/wiki/Packaging:Java#Javadoc_installation
- Javadoc documentation files are generated and included in -javadoc
  subpackage
  Note: No javadoc subpackage present
  See: https://fedoraproject.org/wiki/Packaging:Java#Javadoc_installation
- This seems like a Java package, please install fedora-review-plugin-java to
  get additional checks

---> I don't why fedora-review is saying this when it **is** using the java plugin!

- Large documentation must go in a -doc subpackage. Large could be size (~1MB)
  or number of files.
  Note: Documentation size is 2068480 bytes in 29 files.
  See: http://fedoraproject.org/wiki/Packaging/Guidelines#PackageDocumentation
- update-desktop-database is invoked in %post and %postun if package contains
  desktop file(s) with a MimeType: entry.
  Note: desktop file(s) with MimeType entry in cube
  See: http://fedoraproject.org/wiki/Packaging:ScriptletSnippets#desktop-
  database


===== MUST items =====

C/C++:
[x]: Package does not contain kernel modules.
[x]: Package contains no static executables.
[x]: Header files in -devel subpackage, if present.
[x]: ldconfig called in %post and %postun if required.
[x]: Package does not contain any libtool archives (.la)
[x]: Rpath absent or only used for internal libs.
[x]: Development (unversioned) .so files in -devel subpackage, if present.

Generic:
[x]: Package is licensed with an open-source compatible license and meets
     other legal requirements as defined in the legal section of Packaging
     Guidelines.
[x]: License field in the package spec file matches the actual license.
     Note: Checking patched sources after %prep for licenses. Licenses found:
     "Apache (v2.0)", "GPL (v2 or later)", "GPL (v3 or later)", "Unknown or
     generated". 696 files have unknown license. Detailed output of
     licensecheck in
     /home/mukundan/personal/pkgs/reviews/1013095-cube/licensecheck.txt

---> This is fine. The subset I checked all have BSD license.

[x]: License file installed when any subpackage combination is installed.
[x]: %build honors applicable compiler flags or justifies otherwise.
[x]: Package contains no bundled libraries without FPC exception.
[x]: Changelog in prescribed format.
[x]: Sources contain only permissible code or content.
[x]: Development files must be in a -devel package
[x]: Package uses nothing in %doc for runtime.
[x]: Package consistently uses macros (instead of hard-coded directory names).
[x]: Package is named according to the Package Naming Guidelines.
[x]: Package does not generate any conflict.
[x]: Package obeys FHS, except libexecdir and /usr/target.
[-]: If the package is a rename of another package, proper Obsoletes and
     Provides are present.
[x]: Requires correct, justified where necessary.
[x]: Spec file is legible and written in American English.
[-]: Package contains systemd file(s) if in need.
[x]: Useful -debuginfo package or justification otherwise.
[x]: Package is not known to require an ExcludeArch tag.
[x]: Package complies to the Packaging Guidelines
[x]: Package successfully compiles and builds into binary rpms on at least one
     supported primary architecture.
[x]: Package installs properly.
[x]: Rpmlint is run on all rpms the build produces.
     Note: There are rpmlint messages (see attachment).
[x]: If (and only if) the source package includes the text of the license(s)
     in its own file, then that file, containing the text of the license(s)
     for the package is included in %doc.
[x]: Package requires other packages for directories it uses.
[x]: Package must own all directories that it creates.
[x]: Package does not own files or directories owned by other packages.
[x]: All build dependencies are listed in BuildRequires, except for any that
     are listed in the exceptions section of Packaging Guidelines.
[x]: Package uses either %{buildroot} or $RPM_BUILD_ROOT
[x]: Package does not run rm -rf %{buildroot} (or $RPM_BUILD_ROOT) at the
     beginning of %install.
[x]: Macros in Summary, %description expandable at SRPM build time.
[x]: Package contains desktop file if it is a GUI application.
[x]: Package installs a %{name}.desktop using desktop-file-install or desktop-
     file-validate if there is such a file.
[x]: Package does not contain duplicates in %files.
[x]: Permissions on files are set properly.
[x]: Package use %makeinstall only when make install' ' DESTDIR=... doesn't
     work.
[x]: Package is named using only allowed ASCII characters.
[x]: Package do not use a name that already exist
[x]: Package is not relocatable.
[x]: Sources used to build the package match the upstream source, as provided
     in the spec URL.
[x]: Spec file name must match the spec package %{name}, in the format
     %{name}.spec.
[x]: File names are valid UTF-8.
[x]: Packages must not store files under /srv, /opt or /usr/local

Java:
[x]: Bundled jar/class files should be removed before build

Maven:
[-]: If package contains pom.xml files install it (including depmaps) even
     when building with ant
[x]: Old add_to_maven_depmap macro is not being used

===== SHOULD items =====

Generic:
[!]: Uses parallel make %{?_smp_mflags} macro.

---> Reason for this is given in the spec file. Evaluating.

[-]: If the source package does not include license text(s) as a separate file
     from upstream, the packager SHOULD query upstream to include it.
[x]: Final provides and requires are sane (see attachments).
[?]: Fully versioned dependency in subpackages if applicable.
     Note: No Requires: %{name}%{?_isa} = %{version}-%{release} in cube-doc ,
     cube-java

---> cube-doc is fine, but is this important for cube-java?

[x]: Package functions as described.
[!]: Latest version is packaged.

---> Latest version is 4.2.2 released on Feb 26. Please update.

[x]: Package does not include license text files separate from upstream.
[x]: Patches link to upstream bugs/comments/lists or are otherwise justified.
[x]: Scriptlets must be sane, if used.
[-]: Description and summary sections in the package spec file contains
     translations for supported Non-English languages, if available.
[?]: Package should compile and build into binary rpms on all supported
     architectures.

---> Please do a koji scratch build.

[x]: %check is present and all tests pass.
[x]: Packages should try to preserve timestamps of original installed files.
[x]: Packager, Vendor, PreReq, Copyright tags should not be in spec file
[x]: Sources can be downloaded from URI in Source: tag
[x]: Reviewer should test that the package builds in mock.
[x]: Buildroot is not present
[x]: Package has no %clean section with rm -rf %{buildroot} (or
     $RPM_BUILD_ROOT)
[x]: Dist tag is present (not strictly required in GL).
[x]: No file requires outside of /etc, /bin, /sbin, /usr/bin, /usr/sbin.
[x]: SourceX is a working URL.
[x]: Spec use %global instead of %define unless justified.

Java:
[x]: Packages are noarch unless they use JNI
     Note: cube subpackage is not noarch. Please verify manually
[x]: Package uses upstream build method (ant/maven/etc.)

===== EXTRA items =====

Generic:
[!]: Large data in /usr/share should live in a noarch subpackage if package is
     arched.
     Note: Arch-ed rpms have a total of 2078720 bytes in /usr/share

---> Is this because there is no javadoc subpackage?

[x]: Rpmlint is run on all installed packages.
     Note: There are rpmlint messages (see attachment).
[x]: Spec file according to URL is the same as in SRPM.


Rpmlint
-------
Checking: cube-4.2.1-2.fc21.x86_64.rpm
          cube-devel-4.2.1-2.fc21.x86_64.rpm
          cube-doc-4.2.1-2.fc21.noarch.rpm
          cube-java-4.2.1-2.fc21.noarch.rpm
          cube-4.2.1-2.fc21.src.rpm
cube.x86_64: W: name-repeated-in-summary C CUBE
cube.x86_64: W: spelling-error %description -l en_US scalable -> salable, callable, calculable
cube.x86_64: W: spelling-error %description -l en_US Scalability -> Availability, Sociability, Implacability
cube.x86_64: W: shared-lib-calls-exit /usr/lib64/libcube4w.so.4.2.0 exit@GLIBC_2.2.5
cube.x86_64: W: shared-lib-calls-exit /usr/lib64/libcube4.so.4.2.0 exit@GLIBC_2.2.5

$ rpmlint -I shared-lib-calls-exit
shared-lib-calls-exit:
This library package calls exit() or _exit(), probably in a non-fork()
context. Doing so from a library is strongly discouraged - when a library
function calls exit(), it prevents the calling program from handling the
error, reporting it to the user, closing files properly, and cleaning up any
state that the program has. It is preferred for the library to return an
actual error code and let the calling program decide how to handle the
situation.

---> Please investigate.

cube.x86_64: W: no-manual-page-for-binary cube_remap2
cube.x86_64: W: no-manual-page-for-binary cube3to4
cube.x86_64: W: no-manual-page-for-binary cube_topoassist
cube.x86_64: W: no-manual-page-for-binary cube_is_empty
cube.x86_64: W: no-manual-page-for-binary tau2cube
cube.x86_64: W: no-manual-page-for-binary cube_score
cube.x86_64: W: no-manual-page-for-binary cube_rank
cube.x86_64: W: no-manual-page-for-binary cube_calltree
cube.x86_64: W: no-manual-page-for-binary cube_nodeview
cube.x86_64: W: no-manual-page-for-binary cube_merge
cube.x86_64: W: no-manual-page-for-binary cube_info
cube.x86_64: W: no-manual-page-for-binary cube_cmp
cube.x86_64: W: no-manual-page-for-binary cube_sanity
cube.x86_64: W: no-manual-page-for-binary cube
cube.x86_64: W: no-manual-page-for-binary cube4to3
cube.x86_64: W: no-manual-page-for-binary cube_inclusify
cube.x86_64: W: no-manual-page-for-binary cube_dump
cube.x86_64: W: no-manual-page-for-binary cube_stat
cube.x86_64: W: no-manual-page-for-binary cube_mean
cube.x86_64: W: no-manual-page-for-binary cube_test
cube.x86_64: W: no-manual-page-for-binary cube_part
cube.x86_64: W: no-manual-page-for-binary cube_canonize
cube.x86_64: W: no-manual-page-for-binary cube_clean
cube.x86_64: W: no-manual-page-for-binary cube_diff
cube.x86_64: W: no-manual-page-for-binary cube_exclusify
cube.x86_64: W: no-manual-page-for-binary cube_regioninfo
cube.x86_64: W: no-manual-page-for-binary cube_cut
cube.x86_64: W: no-manual-page-for-binary cube_derive
cube-devel.x86_64: W: no-documentation
cube-devel.x86_64: W: no-manual-page-for-binary cube-config
cube-devel.x86_64: W: no-manual-page-for-binary cube-config-backend
cube-devel.x86_64: W: no-manual-page-for-binary cube-config-frontend
cube-java.noarch: W: no-documentation
cube.src: W: name-repeated-in-summary C CUBE
cube.src: W: spelling-error %description -l en_US scalable -> salable, callable, calculable
cube.src: W: spelling-error %description -l en_US Scalability -> Availability, Sociability, Implacability
cube.src:63: E: hardcoded-library-path in /usr/lib

$ rpmlint -I hardcoded-library-path
hardcoded-library-path:
A library path is hardcoded to one of the following paths: /lib, /usr/lib. It
should be replaced by something like /%{_lib} or %{_libdir}.

---> This is a problem. But, I think this is because of the sed call in the spec file, in which case, it **might** be fine? Must be looked at.

5 packages and 0 specfiles checked; 1 errors, 41 warnings.




Rpmlint (installed packages)
----------------------------
# rpmlint cube-devel cube-java cube-doc cube
cube-devel.x86_64: W: no-documentation
cube-devel.x86_64: W: no-manual-page-for-binary cube-config
cube-devel.x86_64: W: no-manual-page-for-binary cube-config-backend
cube-devel.x86_64: W: no-manual-page-for-binary cube-config-frontend
cube-java.noarch: W: no-documentation
cube.x86_64: W: name-repeated-in-summary C CUBE
cube.x86_64: W: spelling-error %description -l en_US scalable -> salable, callable, calculable
cube.x86_64: W: spelling-error %description -l en_US Scalability -> Availability, Sociability, Implacability
cube.x86_64: W: undefined-non-weak-symbol /usr/lib64/libcubewriter4.so.4.2.0 cube_write_sev_row
cube.x86_64: W: undefined-non-weak-symbol /usr/lib64/libcubewriter4.so.4.2.0 cube_write_sev_row_of_doubles
cube.x86_64: W: undefined-non-weak-symbol /usr/lib64/libcubewriter4.so.4.2.0 cube_create
cube.x86_64: W: undefined-non-weak-symbol /usr/lib64/libcubewriter4.so.4.2.0 cube_set_known_cnodes_for_metric
cube.x86_64: W: undefined-non-weak-symbol /usr/lib64/libcubewriter4.so.4.2.0 cube_write_sev_row_of_uint64
cube.x86_64: W: undefined-non-weak-symbol /usr/lib64/libcubewriter4.so.4.2.0 cube_free

$ rpmlint -I undefined-non-weak-symbol
undefined-non-weak-symbol:
The binary contains undefined non-weak symbols.  This may indicate improper
linkage; check that the binary has been linked as expected.


---> Please take a look at this.

cube.x86_64: W: shared-lib-calls-exit /usr/lib64/libcube4w.so.4.2.0 exit@GLIBC_2.2.5
cube.x86_64: W: shared-lib-calls-exit /usr/lib64/libcube4.so.4.2.0 exit@GLIBC_2.2.5
cube.x86_64: W: no-manual-page-for-binary cube_remap2
cube.x86_64: W: no-manual-page-for-binary cube3to4
cube.x86_64: W: no-manual-page-for-binary cube_topoassist
cube.x86_64: W: no-manual-page-for-binary cube_is_empty
cube.x86_64: W: no-manual-page-for-binary tau2cube
cube.x86_64: W: no-manual-page-for-binary cube_score
cube.x86_64: W: no-manual-page-for-binary cube_rank
cube.x86_64: W: no-manual-page-for-binary cube_calltree
cube.x86_64: W: no-manual-page-for-binary cube_nodeview
cube.x86_64: W: no-manual-page-for-binary cube_merge
cube.x86_64: W: no-manual-page-for-binary cube_info
cube.x86_64: W: no-manual-page-for-binary cube_cmp
cube.x86_64: W: no-manual-page-for-binary cube_sanity
cube.x86_64: W: no-manual-page-for-binary cube
cube.x86_64: W: no-manual-page-for-binary cube4to3
cube.x86_64: W: no-manual-page-for-binary cube_inclusify
cube.x86_64: W: no-manual-page-for-binary cube_dump
cube.x86_64: W: no-manual-page-for-binary cube_stat
cube.x86_64: W: no-manual-page-for-binary cube_mean
cube.x86_64: W: no-manual-page-for-binary cube_test
cube.x86_64: W: no-manual-page-for-binary cube_part
cube.x86_64: W: no-manual-page-for-binary cube_canonize
cube.x86_64: W: no-manual-page-for-binary cube_clean
cube.x86_64: W: no-manual-page-for-binary cube_diff
cube.x86_64: W: no-manual-page-for-binary cube_exclusify
cube.x86_64: W: no-manual-page-for-binary cube_regioninfo
cube.x86_64: W: no-manual-page-for-binary cube_cut
cube.x86_64: W: no-manual-page-for-binary cube_derive
4 packages and 0 specfiles checked; 0 errors, 44 warnings.
# echo 'rpmlint-done:'



Requires
--------
cube-devel (rpmlib, GLIBC filtered):
    /bin/bash
    cube(x86-64)
    libcube4.so.4()(64bit)
    libcube4w.so.4()(64bit)
    libcubewriter4.so.4()(64bit)

cube-java (rpmlib, GLIBC filtered):
    cube
    jpackage-utils

cube-doc (rpmlib, GLIBC filtered):
    /bin/sh

cube (rpmlib, GLIBC filtered):
    /bin/sh
    /sbin/ldconfig
    libQtCore.so.4()(64bit)
    libQtGui.so.4()(64bit)
    libQtNetwork.so.4()(64bit)
    libc.so.6()(64bit)
    libcube4.so.4()(64bit)
    libdbus-1.so.3()(64bit)
    libgcc_s.so.1()(64bit)
    libgcc_s.so.1(GCC_3.0)(64bit)
    libgcc_s.so.1(GCC_4.0.0)(64bit)
    libm.so.6()(64bit)
    libpthread.so.0()(64bit)
    libstdc++.so.6()(64bit)
    libstdc++.so.6(CXXABI_1.3)(64bit)
    libstdc++.so.6(CXXABI_1.3.1)(64bit)
    libz.so.1()(64bit)
    rtld(GNU_HASH)



Provides
--------
cube-devel:
    cube-devel
    cube-devel(x86-64)

cube-java:
    cube-java

cube-doc:
    cube-doc

cube:
    application()
    application(CUBE.desktop)
    cube
    cube(x86-64)
    libcube4.so.4()(64bit)
    libcube4w.so.4()(64bit)
    libcubewriter4.so.4()(64bit)
    mimehandler(application/cube)



Source checksums
----------------
http://apps.fz-juelich.de/scalasca/releases/cube/4.2/dist/cube-4.2.1.tar.gz :
  CHECKSUM(SHA256) this package     : c24c6e1e2bc6fcf89a2a68d78c7baadbcc7100ea91e9c04c02696dafa0cd1f49
  CHECKSUM(SHA256) upstream package : c24c6e1e2bc6fcf89a2a68d78c7baadbcc7100ea91e9c04c02696dafa0cd1f49


Generated by fedora-review 0.5.1 (bb9bf27) last change: 2013-12-13
Command line :/usr/bin/fedora-review -b 1013095
Buildroot used: fedora-rawhide-x86_64
Active plugins: Generic, Shell-api, Java, C/C++
Disabled plugins: Python, SugarActivity, fonts, Haskell, Ocaml, Perl, R, PHP, Ruby
Disabled flags: EXARCH, EPEL5, BATCH, DISTTAG
Comment 7 Orion Poplawski 2014-03-03 17:17:38 EST
(In reply to Mukundan Ragavan from comment #6)
> Issues:
> =======
> - Packages have proper BuildRequires/Requires on jpackage-utils
> 
> ---> BuildRequires and cube-java has Requires: jpackage-utils - looks fine.
> Does cube also require this? Requires does not show that below.

No.

> - gtk-update-icon-cache is invoked in %postun and %posttrans if package
>   contains icons.
>   Note: icons in cube
>   See: http://fedoraproject.org/wiki/Packaging:ScriptletSnippets#Icon_Cache

Fixed.

> - Javadocs are placed in %{_javadocdir}/%{name} (no -%{version} symlink)
>   Note: No javadoc subpackage present
>   See: https://fedoraproject.org/wiki/Packaging:Java#Javadoc_installation
> - Javadoc documentation files are generated and included in -javadoc
>   subpackage
>   Note: No javadoc subpackage present
>   See: https://fedoraproject.org/wiki/Packaging:Java#Javadoc_installation

Yeah, this package doesn't provide a way to build it, and I'm not able to do it by hand.  The Java folks are talking about making this optional as well.

> - This seems like a Java package, please install fedora-review-plugin-java to
>   get additional checks
> 
> ---> I don't why fedora-review is saying this when it **is** using the java
> plugin!

Hmm, file a bug :)

> - Large documentation must go in a -doc subpackage. Large could be size
> (~1MB)
>   or number of files.
>   Note: Documentation size is 2068480 bytes in 29 files.
>   See:
> http://fedoraproject.org/wiki/Packaging/Guidelines#PackageDocumentation

I was ending up with duplicated docs.  Fixed.

> - update-desktop-database is invoked in %post and %postun if package contains
>   desktop file(s) with a MimeType: entry.
>   Note: desktop file(s) with MimeType entry in cube
>   See: http://fedoraproject.org/wiki/Packaging:ScriptletSnippets#desktop-
>   database

Fixed.

> [?]: Fully versioned dependency in subpackages if applicable.
>      Note: No Requires: %{name}%{?_isa} = %{version}-%{release} in cube-doc ,
>      cube-java
> 
> ---> cube-doc is fine, but is this important for cube-java?

No, java is noarch.

> [x]: Package functions as described.
> [!]: Latest version is packaged.
> 
> ---> Latest version is 4.2.2 released on Feb 26. Please update.

Done.

> [?]: Package should compile and build into binary rpms on all supported
>      architectures.
> 
> ---> Please do a koji scratch build.

http://koji.fedoraproject.org/koji/taskinfo?taskID=6592007

> Generic:
> [!]: Large data in /usr/share should live in a noarch subpackage if package
> is
>      arched.
>      Note: Arch-ed rpms have a total of 2078720 bytes in /usr/share
> 
> ---> Is this because there is no javadoc subpackage?

No, the duplicated docs above.

> Rpmlint
> -------
> Checking: cube-4.2.1-2.fc21.x86_64.rpm
>           cube-devel-4.2.1-2.fc21.x86_64.rpm
>           cube-doc-4.2.1-2.fc21.noarch.rpm
>           cube-java-4.2.1-2.fc21.noarch.rpm
>           cube-4.2.1-2.fc21.src.rpm

> cube.x86_64: W: shared-lib-calls-exit /usr/lib64/libcube4.so.4.2.0
> exit@GLIBC_2.2.5
> 
> $ rpmlint -I shared-lib-calls-exit
> shared-lib-calls-exit:
> This library package calls exit() or _exit(), probably in a non-fork()
> context. Doing so from a library is strongly discouraged - when a library
> function calls exit(), it prevents the calling program from handling the
> error, reporting it to the user, closing files properly, and cleaning up any
> state that the program has. It is preferred for the library to return an
> actual error code and let the calling program decide how to handle the
> situation.
> 
> ---> Please investigate.

Upstream response:

note that the scorep libraries call exit()/_exit() as well. Here it is
not always possible for the user to evaluate return codes. E.g., when
using compiler instrumentation, function calls that possibly fail are
inserted by the compiler. There is no way the user can handle this.

> cube.src:63: E: hardcoded-library-path in /usr/lib
> 
> $ rpmlint -I hardcoded-library-path
> hardcoded-library-path:
> A library path is hardcoded to one of the following paths: /lib, /usr/lib. It
> should be replaced by something like /%{_lib} or %{_libdir}.
> 
> ---> This is a problem. But, I think this is because of the sed call in the
> spec file, in which case, it **might** be fine? Must be looked at.

With 4.2.2 as I ended up moving to using chrpath to strip the rpaths.  This seems to be gone with that.

> Rpmlint (installed packages)
> ----------------------------

> cube.x86_64: W: undefined-non-weak-symbol /usr/lib64/libcubewriter4.so.4.2.0
> cube_write_sev_row
> cube.x86_64: W: undefined-non-weak-symbol /usr/lib64/libcubewriter4.so.4.2.0
> cube_write_sev_row_of_doubles
> cube.x86_64: W: undefined-non-weak-symbol /usr/lib64/libcubewriter4.so.4.2.0
> cube_create
> cube.x86_64: W: undefined-non-weak-symbol /usr/lib64/libcubewriter4.so.4.2.0
> cube_set_known_cnodes_for_metric
> cube.x86_64: W: undefined-non-weak-symbol /usr/lib64/libcubewriter4.so.4.2.0
> cube_write_sev_row_of_uint64
> cube.x86_64: W: undefined-non-weak-symbol /usr/lib64/libcubewriter4.so.4.2.0
> cube_free
> 
> $ rpmlint -I undefined-non-weak-symbol
> undefined-non-weak-symbol:
> The binary contains undefined non-weak symbols.  This may indicate improper
> linkage; check that the binary has been linked as expected.
> 
> 
> ---> Please take a look at this.

I've reported this upstream.  As it stands I don't believe it is an issue because cube users use cube-config to get the libraries to link to.

* Mon Mar 3 2014 Orion Poplawski <orion@cora.nwra.com> - 4.2.2-1
- Update to 4.2.2
- Fix doc duplication
- Add icon and destop-database scriptlets
- Use chrpath to strip rpaths

http://www.cora.nwra.com/~orion/fedora/cube.spec
http://www.cora.nwra.com/~orion/fedora/cube-4.2.2-1.fc20.src.rpm
Comment 8 Mukundan Ragavan 2014-03-03 17:37:32 EST
Thanks for the scatch build. I don't think (based on some old reviews) shared-lib-calls-exit is a blocker. So, that should be fine.

(In reply to Orion Poplawski from comment #7)
> 
> > [?]: Fully versioned dependency in subpackages if applicable.
> >      Note: No Requires: %{name}%{?_isa} = %{version}-%{release} in cube-doc ,
> >      cube-java
> > 
> > ---> cube-doc is fine, but is this important for cube-java?
> 
> No, java is noarch.

That was at best a silly question on my part. Sigh!

I will look at this again later today.
Comment 9 Mukundan Ragavan 2014-03-04 11:11:40 EST
Alright, here we go.


Package Review
==============

Legend:
[x] = Pass, [!] = Fail, [-] = Not applicable, [?] = Not evaluated
[ ] = Manual review needed


Issues:
=======
- Packages have proper BuildRequires/Requires on jpackage-utils

---> This is fine.

- Javadocs are placed in %{_javadocdir}/%{name} (no -%{version} symlink)
  Note: No javadoc subpackage present
  See: https://fedoraproject.org/wiki/Packaging:Java#Javadoc_installation
- Javadoc documentation files are generated and included in -javadoc
  subpackage
  Note: No javadoc subpackage present
  See: https://fedoraproject.org/wiki/Packaging:Java#Javadoc_installation


---> Reasons are given in comment 7.

- This seems like a Java package, please install fedora-review-plugin-java to
  get additional checks

---> Bug in fedora-review (will file soon).


===== MUST items =====

C/C++:
[x]: Package does not contain kernel modules.
[x]: Package contains no static executables.
[x]: Header files in -devel subpackage, if present.
[x]: ldconfig called in %post and %postun if required.
[x]: Package does not contain any libtool archives (.la)
[x]: Rpath absent or only used for internal libs.
[x]: Development (unversioned) .so files in -devel subpackage, if present.

Generic:
[x]: Package is licensed with an open-source compatible license and meets
     other legal requirements as defined in the legal section of Packaging
     Guidelines.
[x]: License field in the package spec file matches the actual license.
     Note: Checking patched sources after %prep for licenses. Licenses found:
     "Apache (v2.0)", "GPL (v2 or later)", "GPL (v3 or later)", "Unknown or
     generated". 721 files have unknown license. Detailed output of
     licensecheck in
     /home/mukundan/personal/pkgs/reviews/1013095-cube/licensecheck.txt

---> No problems.

[x]: License file installed when any subpackage combination is installed.
[x]: %build honors applicable compiler flags or justifies otherwise.
[x]: Package contains no bundled libraries without FPC exception.
[x]: Changelog in prescribed format.
[x]: Sources contain only permissible code or content.
[x]: Development files must be in a -devel package
[x]: Package uses nothing in %doc for runtime.
[x]: Package consistently uses macros (instead of hard-coded directory names).
[x]: Package is named according to the Package Naming Guidelines.
[x]: Package does not generate any conflict.
[x]: Package obeys FHS, except libexecdir and /usr/target.
[-]: If the package is a rename of another package, proper Obsoletes and
     Provides are present.
[x]: Requires correct, justified where necessary.
[x]: Spec file is legible and written in American English.
[-]: Package contains systemd file(s) if in need.
[x]: update-desktop-database is invoked in %post and %postun if package
     contains desktop file(s) with a MimeType: entry.
     Note: desktop file(s) with MimeType entry in cube
[x]: gtk-update-icon-cache is invoked in %postun and %posttrans if package
     contains icons.
     Note: icons in cube
[x]: Useful -debuginfo package or justification otherwise.
[x]: Package is not known to require an ExcludeArch tag.
[-]: Large documentation must go in a -doc subpackage. Large could be size
     (~1MB) or number of files.
     Note: Documentation size is 20480 bytes in 5 files.
[x]: Package complies to the Packaging Guidelines
[x]: Package successfully compiles and builds into binary rpms on at least one
     supported primary architecture.
[x]: Package installs properly.
[x]: Rpmlint is run on all rpms the build produces.
     Note: There are rpmlint messages (see attachment).
[x]: If (and only if) the source package includes the text of the license(s)
     in its own file, then that file, containing the text of the license(s)
     for the package is included in %doc.
[x]: Package requires other packages for directories it uses.
[x]: Package must own all directories that it creates.
[x]: Package does not own files or directories owned by other packages.
[x]: All build dependencies are listed in BuildRequires, except for any that
     are listed in the exceptions section of Packaging Guidelines.
[x]: Package uses either %{buildroot} or $RPM_BUILD_ROOT
[x]: Package does not run rm -rf %{buildroot} (or $RPM_BUILD_ROOT) at the
     beginning of %install.
[x]: Macros in Summary, %description expandable at SRPM build time.
[x]: Package contains desktop file if it is a GUI application.
[x]: Package installs a %{name}.desktop using desktop-file-install or desktop-
     file-validate if there is such a file.
[x]: Package does not contain duplicates in %files.
[x]: Permissions on files are set properly.
[x]: Package use %makeinstall only when make install' ' DESTDIR=... doesn't
     work.
[x]: Package is named using only allowed ASCII characters.
[x]: Package do not use a name that already exist
[x]: Package is not relocatable.
[x]: Sources used to build the package match the upstream source, as provided
     in the spec URL.
[x]: Spec file name must match the spec package %{name}, in the format
     %{name}.spec.
[x]: File names are valid UTF-8.
[x]: Packages must not store files under /srv, /opt or /usr/local

Java:
[x]: Bundled jar/class files should be removed before build

Maven:
[-]: If package contains pom.xml files install it (including depmaps) even
     when building with ant
[x]: Old add_to_maven_depmap macro is not being used

===== SHOULD items =====

Generic:
[!]: Uses parallel make %{?_smp_mflags} macro.

---> Reason given in the spec file. Marking [x]

[-]: If the source package does not include license text(s) as a separate file
     from upstream, the packager SHOULD query upstream to include it.
[x]: Final provides and requires are sane (see attachments).
[-]: Fully versioned dependency in subpackages if applicable.
     Note: No Requires: %{name}%{?_isa} = %{version}-%{release} in cube-doc ,
     cube-java
[x]: Package functions as described.
[x]: Latest version is packaged.
[x]: Package does not include license text files separate from upstream.
[x]: Patches link to upstream bugs/comments/lists or are otherwise justified.
[-]: Description and summary sections in the package spec file contains
     translations for supported Non-English languages, if available.
[x]: Package should compile and build into binary rpms on all supported
     architectures.

---> Koji builds are good.

[x]: %check is present and all tests pass.

---> Look good. Partial output from build.log below

     Copy 113th metric imbalance_below_singularity of 114 (210/300)
     Copy 113th metric imbalance_below_singularity of 114 (225/300)
     Copy 113th metric imbalance_below_singularity of 114 (240/300)
     Copy 113th metric imbalance_below_singularity of 114 (255/300)
     Copy 113th metric imbalance_below_singularity of 114 (270/300)
     Copy 113th metric imbalance_below_singularity of 114 (285/300)
     Copy 113th metric imbalance_below_singularity of 114 (300/300)
++++++++++++ Remapping operation ends successfully ++++++++++++++++
Writing remap ... done.
=====> Compare result with saved template using cube_cmp
Reading remap.cubex ... done.
Reading /builddir/build/BUILD/cube-4.2.2/build-backend/../test/test29/template.cube ... done.
++++++++++++ Compare operation begins ++++++++++++++++++++++++++
 Compare metric dimensions...equal.
 Compare calltree dimensions.equal.
 Compare system dimensions...equal.
 Compare data...equal.
Experiments are equal.
+++++++++++++ Compare operation ends successfully ++++++++++++++++
PASS: ../test/test29/run_test_29.sh
===================
All 31 tests passed



[x]: Packages should try to preserve timestamps of original installed files.
[x]: Packager, Vendor, PreReq, Copyright tags should not be in spec file
[x]: Sources can be downloaded from URI in Source: tag
[x]: Reviewer should test that the package builds in mock.
[x]: Buildroot is not present
[x]: Package has no %clean section with rm -rf %{buildroot} (or
     $RPM_BUILD_ROOT)
[x]: Dist tag is present (not strictly required in GL).
[x]: No file requires outside of /etc, /bin, /sbin, /usr/bin, /usr/sbin.
[x]: SourceX is a working URL.
[x]: Spec use %global instead of %define unless justified.

Java:
[x]: Packages are noarch unless they use JNI
     Note: cube subpackage is not noarch. Please verify manually
[x]: Package uses upstream build method (ant/maven/etc.)

===== EXTRA items =====

Generic:
[x]: Rpmlint is run on all installed packages.
     Note: There are rpmlint messages (see attachment).
[x]: Large data in /usr/share should live in a noarch subpackage if package is
     arched.
[x]: Spec file according to URL is the same as in SRPM.


Rpmlint
-------
Checking: cube-4.2.2-1.fc21.x86_64.rpm
          cube-devel-4.2.2-1.fc21.x86_64.rpm
          cube-doc-4.2.2-1.fc21.noarch.rpm
          cube-java-4.2.2-1.fc21.noarch.rpm
          cube-4.2.2-1.fc21.src.rpm
cube.x86_64: W: name-repeated-in-summary C CUBE
cube.x86_64: W: spelling-error %description -l en_US scalable -> salable, callable, calculable
cube.x86_64: W: spelling-error %description -l en_US Scalability -> Availability, Sociability, Implacability
cube.x86_64: W: invalid-url URL: http://www.scalasca.org/software/cube-4.x/download.html timed out

---> Network problem.

cube.x86_64: W: shared-lib-calls-exit /usr/lib64/libcube4.so.4.2.1 exit@GLIBC_2.2.5
cube.x86_64: W: shared-lib-calls-exit /usr/lib64/libcube4w.so.4.2.1 exit@GLIBC_2.2.5

---> Reason given in comment 7.

cube.x86_64: W: no-manual-page-for-binary cube_remap2
cube.x86_64: W: no-manual-page-for-binary cube3to4
cube.x86_64: W: no-manual-page-for-binary cube_topoassist
cube.x86_64: W: no-manual-page-for-binary cube_is_empty
cube.x86_64: W: no-manual-page-for-binary tau2cube
cube.x86_64: W: no-manual-page-for-binary cube_score
cube.x86_64: W: no-manual-page-for-binary cube_rank
cube.x86_64: W: no-manual-page-for-binary cube_calltree
cube.x86_64: W: no-manual-page-for-binary cube_nodeview
cube.x86_64: W: no-manual-page-for-binary cube_merge
cube.x86_64: W: no-manual-page-for-binary cube_info
cube.x86_64: W: no-manual-page-for-binary cube_cmp
cube.x86_64: W: no-manual-page-for-binary cube_sanity
cube.x86_64: W: no-manual-page-for-binary cube
cube.x86_64: W: no-manual-page-for-binary cube4to3
cube.x86_64: W: no-manual-page-for-binary cube_inclusify
cube.x86_64: W: no-manual-page-for-binary cube_dump
cube.x86_64: W: no-manual-page-for-binary cube_stat
cube.x86_64: W: no-manual-page-for-binary cube_mean
cube.x86_64: W: no-manual-page-for-binary cube_test
cube.x86_64: W: no-manual-page-for-binary cube_part
cube.x86_64: W: no-manual-page-for-binary cube_canonize
cube.x86_64: W: no-manual-page-for-binary cube_clean
cube.x86_64: W: no-manual-page-for-binary cube_diff
cube.x86_64: W: no-manual-page-for-binary cube_exclusify
cube.x86_64: W: no-manual-page-for-binary cube_regioninfo
cube.x86_64: W: no-manual-page-for-binary cube_cut
cube.x86_64: W: no-manual-page-for-binary cube_derive
cube-devel.x86_64: W: no-documentation
cube-devel.x86_64: W: no-manual-page-for-binary cube-config
cube-devel.x86_64: W: no-manual-page-for-binary cube-config-backend
cube-devel.x86_64: W: no-manual-page-for-binary cube-config-frontend
cube-java.noarch: W: no-documentation
cube.src: W: name-repeated-in-summary C CUBE
cube.src: W: spelling-error %description -l en_US scalable -> salable, callable, calculable
cube.src: W: spelling-error %description -l en_US Scalability -> Availability, Sociability, Implacability
5 packages and 0 specfiles checked; 0 errors, 42 warnings.




Rpmlint (installed packages)
----------------------------
# rpmlint cube-devel cube-java cube-doc cube
cube-devel.x86_64: W: invalid-url URL: http://www.scalasca.org/software/cube-4.x/download.html timed out
cube-devel.x86_64: W: no-documentation
cube-devel.x86_64: W: no-manual-page-for-binary cube-config
cube-devel.x86_64: W: no-manual-page-for-binary cube-config-backend
cube-devel.x86_64: W: no-manual-page-for-binary cube-config-frontend
cube-java.noarch: W: invalid-url URL: http://www.scalasca.org/software/cube-4.x/download.html timed out
cube-java.noarch: W: no-documentation
cube.x86_64: W: name-repeated-in-summary C CUBE
cube.x86_64: W: spelling-error %description -l en_US scalable -> salable, callable, calculable
cube.x86_64: W: spelling-error %description -l en_US Scalability -> Availability, Sociability, Implacability
cube.x86_64: W: undefined-non-weak-symbol /usr/lib64/libcubewriter4.so.4.2.1 cube_write_sev_row
cube.x86_64: W: undefined-non-weak-symbol /usr/lib64/libcubewriter4.so.4.2.1 cube_write_sev_row_of_doubles
cube.x86_64: W: undefined-non-weak-symbol /usr/lib64/libcubewriter4.so.4.2.1 cube_create
cube.x86_64: W: undefined-non-weak-symbol /usr/lib64/libcubewriter4.so.4.2.1 cube_set_known_cnodes_for_metric
cube.x86_64: W: undefined-non-weak-symbol /usr/lib64/libcubewriter4.so.4.2.1 cube_write_sev_row_of_uint64
cube.x86_64: W: undefined-non-weak-symbol /usr/lib64/libcubewriter4.so.4.2.1 cube_free

---> From what I can tell, this seems fine.

cube.x86_64: W: shared-lib-calls-exit /usr/lib64/libcube4.so.4.2.1 exit@GLIBC_2.2.5
cube.x86_64: W: shared-lib-calls-exit /usr/lib64/libcube4w.so.4.2.1 exit@GLIBC_2.2.5
cube.x86_64: W: no-manual-page-for-binary cube_remap2
cube.x86_64: W: no-manual-page-for-binary cube3to4
cube.x86_64: W: no-manual-page-for-binary cube_topoassist
cube.x86_64: W: no-manual-page-for-binary cube_is_empty
cube.x86_64: W: no-manual-page-for-binary tau2cube
cube.x86_64: W: no-manual-page-for-binary cube_score
cube.x86_64: W: no-manual-page-for-binary cube_rank
cube.x86_64: W: no-manual-page-for-binary cube_calltree
cube.x86_64: W: no-manual-page-for-binary cube_nodeview
cube.x86_64: W: no-manual-page-for-binary cube_merge
cube.x86_64: W: no-manual-page-for-binary cube_info
cube.x86_64: W: no-manual-page-for-binary cube_cmp
cube.x86_64: W: no-manual-page-for-binary cube_sanity
cube.x86_64: W: no-manual-page-for-binary cube
cube.x86_64: W: no-manual-page-for-binary cube4to3
cube.x86_64: W: no-manual-page-for-binary cube_inclusify
cube.x86_64: W: no-manual-page-for-binary cube_dump
cube.x86_64: W: no-manual-page-for-binary cube_stat
cube.x86_64: W: no-manual-page-for-binary cube_mean
cube.x86_64: W: no-manual-page-for-binary cube_test
cube.x86_64: W: no-manual-page-for-binary cube_part
cube.x86_64: W: no-manual-page-for-binary cube_canonize
cube.x86_64: W: no-manual-page-for-binary cube_clean
cube.x86_64: W: no-manual-page-for-binary cube_diff
cube.x86_64: W: no-manual-page-for-binary cube_exclusify
cube.x86_64: W: no-manual-page-for-binary cube_regioninfo
cube.x86_64: W: no-manual-page-for-binary cube_cut
cube.x86_64: W: no-manual-page-for-binary cube_derive
4 packages and 0 specfiles checked; 0 errors, 46 warnings.
# echo 'rpmlint-done:'



Requires
--------
cube-devel (rpmlib, GLIBC filtered):
    /bin/bash
    cube(x86-64)
    libcube4.so.4()(64bit)
    libcube4w.so.4()(64bit)
    libcubewriter4.so.4()(64bit)

cube-java (rpmlib, GLIBC filtered):
    cube
    java
    jpackage-utils

cube-doc (rpmlib, GLIBC filtered):
    /bin/sh

cube (rpmlib, GLIBC filtered):
    /bin/sh
    libQtCore.so.4()(64bit)
    libQtGui.so.4()(64bit)
    libQtNetwork.so.4()(64bit)
    libc.so.6()(64bit)
    libcube4.so.4()(64bit)
    libdbus-1.so.3()(64bit)
    libgcc_s.so.1()(64bit)
    libgcc_s.so.1(GCC_3.0)(64bit)
    libgcc_s.so.1(GCC_4.0.0)(64bit)
    libm.so.6()(64bit)
    libpthread.so.0()(64bit)
    libstdc++.so.6()(64bit)
    libstdc++.so.6(CXXABI_1.3)(64bit)
    libstdc++.so.6(CXXABI_1.3.1)(64bit)
    libz.so.1()(64bit)
    rtld(GNU_HASH)



Provides
--------
cube-devel:
    cube-devel
    cube-devel(x86-64)

cube-java:
    cube-java

cube-doc:
    cube-doc

cube:
    application()
    application(CUBE.desktop)
    cube
    cube(x86-64)
    libcube4.so.4()(64bit)
    libcube4w.so.4()(64bit)
    libcubewriter4.so.4()(64bit)
    mimehandler(application/cube)



Source checksums
----------------
http://apps.fz-juelich.de/scalasca/releases/cube/4.2/dist/cube-4.2.2.tar.gz :
  CHECKSUM(SHA256) this package     : 67a7e2b3cf4927620fc4e987d6fae76b753a74303b3c9d30ea2e0937e64ae82a
  CHECKSUM(SHA256) upstream package : 67a7e2b3cf4927620fc4e987d6fae76b753a74303b3c9d30ea2e0937e64ae82a


Generated by fedora-review 0.5.1 (bb9bf27) last change: 2013-12-13
Command line :/usr/bin/fedora-review -m fedora-rawhide-x86_64 -b 1013095
Buildroot used: fedora-rawhide-x86_64
Active plugins: Generic, Shell-api, Java, C/C++
Disabled plugins: Python, SugarActivity, fonts, Haskell, Ocaml, Perl, R, PHP, Ruby
Disabled flags: EXARCH, EPEL5, BATCH, DISTTAG



Package APPROVED.
Comment 10 Orion Poplawski 2014-03-04 11:17:50 EST
Thanks for the review.

New Package SCM Request
=======================
Package Name: cube
Short Description: CUBE Uniform Behavioral Encoding generic presentation component
Owners: orion
Branches: f19 f20 el6 epel7
InitialCC:
Comment 11 Gwyn Ciesla 2014-03-06 08:23:35 EST
Git done (by process-git-requests).
Comment 12 Orion Poplawski 2014-03-06 12:14:20 EST
Checked in and built.  Thanks all.
Comment 13 Mukundan Ragavan 2014-03-27 16:06:12 EDT
Can we close this review request now since the package is already built? All good?
Comment 14 Orion Poplawski 2014-03-27 19:15:18 EDT
Oops, yup.

Note You need to log in before you can comment on or make changes to this bug.